package RSSReader::Exporter;

use strict;
use Data::Dumper;
use base qw( RSSReader::Logger );

our $_exporters_registred;

sub register {
  my $s = shift;
  my %a = @_;

  return unless ($a{id} && $a{package});
  $_exporters_registred->{$a{id}} = $a{package};
  $s->log_debug("Got a exporter register : $a{id} ($a{package})");
}

sub get_exporter {
	my $c = shift;
	my $id = shift;

	$c->log_debug("Exporter $id was requested (".$_exporters_registred->{$id}.")");
	if (exists($_exporters_registred->{$id}) && defined($_exporters_registred->{$id}) ) {
		my $_not;
		eval {
		  $_not = ($_exporters_registred->{$id})->new()
		};
		if ($@) {
		  __PACKAGE__->log_warn("Could not load exporter $id: $@");
		  return undef;
		}
		return $_not;

	}
	return undef
}

sub get_exporters {
	my @to_ret = ();

	foreach ( keys %$_exporters_registred ) {
		push @to_ret, __PACKAGE__->get_exporter($_);
	}
	return wantarray ? @to_ret : \@to_ret;
}

#Auto discover
my $myname = __PACKAGE__;
my $me = $myname;
$me =~ s/\:\:/\//g;

foreach my $d (@INC) {
   chomp $d;
   if (-d "$d/$me/") {
     local(*F_DIR);
     opendir(*F_DIR, "$d/$me/");
     while ( my $b = readdir(*F_DIR)) {
         next unless $b =~ /^(.*)\.pm$/;
         __PACKAGE__->log_debug("Found exporter $1"); 
	 my $package_name = __PACKAGE__."::$1";
	 eval "require $package_name";
     }
   }
}
	
1;
