package RSSReader::Gtk2UI::AddACategory;
use strict;
use RSSReader::Gtk2UI::Dialog;
use RSSReader::Gtk2UI::MainWindow;
use RSSReader::Category;

sub run {
  my $c = shift;
  my %a = @_;
  die "I need the parent category" unless $a{category};

  my $window = new Gtk2::Window('toplevel');
  $window->set_title("Create a new category");
  $window->set_modal(1);
  $window->set_transient_for( RSSReader::Gtk2UI::MainWindow->new()->widget );

  my $vbox = new Gtk2::VBox;
  $window->add($vbox); 

  my $name_l= new Gtk2::Label('  Please insert the name of the new category  ');
  my $name_e = new Gtk2::Entry( ); 
  $vbox->pack_start($name_l ,0,0,5);
  $vbox->pack_start($name_e ,0,0,5);

  
  my $ok_button=  Gtk2::Button->new_from_stock('gtk-ok');
  my $cancel_button= Gtk2::Button->new_from_stock('gtk-cancel');
  my $bbox = new Gtk2::HButtonBox();
  $bbox->add($ok_button);
  $bbox->add($cancel_button);
  $bbox->set_layout_default('end');
  $bbox->set_spacing_default( 3);
  $bbox->show_all;
  
  $vbox->pack_start(Gtk2::HSeparator->new,0,0,0);
  $vbox->pack_start($bbox,0,0,1);

  $window->show_all();

  my $s = bless { _widget 		=> $window, 
  		  _name_entry 		=> $name_e, 
		  _cat			=> $a{category}, 
		}, $c;
  $ok_button->signal_connect('clicked', sub { $s->create_it() });
  $cancel_button->signal_connect('clicked', sub { $s->{_widget}->hide } );
}

sub create_it {
  my $s = shift;

  my $interval;
  unless ($s->{_name_entry}->get_text()) {
  	RSSReader::Gtk2UI::Dialog->run('Please insert a name to the new category'); 
	return;
  }

  RSSReader::Category->create( location	 		=> $s->{_cat},
			       label    		=> $s->{_name_entry}->get_text(),
			      );

  $s->{_widget}->destroy();
  return 1;
}
1;
