package RSSReader::Gtk2UI::Feed::Properties;

sub run {
  my $c    = shift;
  my $feed = shift;
  return unless $feed;

  my $w    = new Gnome2::App('feed_properties', "\'".$feed->label()."\' properties");
  my $vbox = new Gtk2::VBox; 
  $w->set_contents($vbox);
  $w->set_default_size( 530, 300 );
  $w->set_modal(1);

  my $notebook = new Gtk2::Notebook();
  $vbox->pack_start($notebook,1,1,1);
  $notebook->set_tab_pos('top');

  my $s = bless { _feed => $feed }, $c;

  #PAGE 1;
  my $vbox_page1 = new Gtk2::VBox; 
  my $page1_label = new Gtk2::Label('Properties');
  $notebook->append_page( $vbox_page1, $page1_label);

    # ZEEE TABLE
    $s->{_apply_page1} = Gtk2::Button->new_from_stock('gtk-apply'); 
    $s->{_apply_page1}->set_sensitive(0);
    $s->{_apply_page1}->signal_connect('clicked', sub { $s->_apply_changes });
    $s->{_close_page1} = Gtk2::Button->new_from_stock('gtk-close');
    $s->{_close_page1}->signal_connect('clicked', sub { $w->destroy });

    my $table_page1 = new Gtk2::Table(6,6,0);
    my $name_l = new Gtk2::Label('Name ');
    $name_l->set_alignment(1.0, 0.0);
    $s->{_name_e} = new Gtk2::Entry();
    $s->{_name_e}->set_text($feed->label());
    $s->{_name_e}->signal_connect('changed', sub {$s->_activate_apply});

    my $url_l = new Gtk2::Label('Url ');
    $url_l->set_alignment(1.0, 0.0);
    $s->{_url_e} = new Gtk2::Entry();
    $s->{_url_e}->set_text($feed->url());
    $s->{_url_e}->signal_connect('changed', sub {$s->_activate_apply});

    my $fecth_int_l = new Gtk2::Label('Fecth interval (Mins)');
    my $adj = new Gtk2::Adjustment( 1.0, 0.0, 36000, 1.0, 10.0, undef );
    $s->{_fetch_int_s} = new Gtk2::SpinButton( $adj, '0.5', 0 );
    $s->{_fetch_int_d} = new Gtk2::CheckButton("Use default");

    if ( $feed->fetch_interval) {
	 $s->{_fetch_int_d}->set_active( 0 );
	 $s->{_fetch_int_s}->set_value( $feed->fetch_interval ); 
    } else {
	 $s->{_fetch_int_s}->set_sensitive(0);
	 $s->{_fetch_int_d}->set_active( 1 );
    }

    $s->{_fetch_int_s}->signal_connect('changed', sub {$s->_activate_apply});
    $s->{_fetch_int_d}->signal_connect_after('toggled', 
    					     sub{
					     	$s->_activate_apply; 
						if ($s->{_fetch_int_d}->get_active) {
							$s->{_fetch_int_s}->set_sensitive(0) } 
						else {$s->{_fetch_int_s}->set_sensitive(1)} 
					     }
					     );

    my $notify_l = new Gtk2::Label('Notify new messages');
    $s->{_notify_b} = new Gtk2::CheckButton();
    $s->{_notify_b}->set_active(1) if $feed->notify_new_messages;
    $s->{_notify_b}->signal_connect_after('toggled',  sub {$s->_activate_apply});

    my $keep_for_x        = new Gtk2::Label("Keep messages on\n this feed for");
    my $adj2		  = new Gtk2::Adjustment( 1.0, 0.0, 365, 1.0, 10.0, undef );
    $s->{keep_for_x_s}    = new Gtk2::SpinButton( $adj2, '0.5', 0 );
    my $keep_for_x2       = new Gtk2::Label('days after they were fetched');
    $s->{keep_for_x_s}->set_value( ($feed->keep_for_n/86400)  );
    $s->{keep_for_x_s}->signal_connect('changed', sub {$s->_activate_apply});
    
    $table_page1->attach($name_l             ,0,1,0,1,['fill','shrink']         , [], 5,5);
    $table_page1->attach($s->{_name_e}       ,1,2,0,1,['fill','shrink','expand'], [], 5,5);
    $table_page1->attach($url_l              ,0,1,1,2,['fill','shrink']         , [], 5,5);
    $table_page1->attach($s->{_url_e}        ,1,2,1,2,['fill','shrink','expand'], [], 5,5);
    $table_page1->attach($fecth_int_l        ,0,1,2,3,['fill','shrink']         , [], 5,5);
    $table_page1->attach($s->{_fetch_int_s}  ,1,2,2,3,['fill','shrink','expand'], [], 5,5);
    $table_page1->attach($s->{_fetch_int_d}  ,2,3,2,3,['fill','shrink']         , [], 5,5);
    $table_page1->attach($notify_l           ,0,1,3,4,['fill','shrink']         , [], 5,5);
    $table_page1->attach($s->{_notify_b}     ,1,2,3,4,['fill','shrink']         , [], 5,5);
    $table_page1->attach($keep_for_x	     ,0,1,4,5,['fill','shrink']         , [], 5,5);
    $table_page1->attach($s->{keep_for_x_s}  ,1,2,4,5,['fill','shrink']         , [], 5,5);
    $table_page1->attach($keep_for_x2        ,2,3,4,5,['fill','shrink']         , [], 5,5);

    $table_page1->show_all();

    

  $vbox_page1->pack_start($table_page1, 1,1,10);

  #PAGE 2;
  my $vbox_page2= new Gtk2::VBox;
  my $page2_label = new Gtk2::Label('Information');
  $notebook->append_page( $vbox_page2, $page2_label );

    my $table_page2 = new Gtk2::Table(5,5,0);

    #STATUS
    $status_l = new Gtk2::Label(" Feed status :");
    $status_l->set_alignment(1.0, 0.0);
    $status_t = new Gtk2::Label();
    $status_t->set_alignment(0.0, 0.0);
    if ( $feed->fetches_failed ) {
	$status_t->set_text("Failed the last ".$feed->fetches_failed." fetch attempts");	
    } else {
	$status_t->set_text("Alive, last fetch attempt was successful");
    }

    #LAST FETCH
    $last_f_l = new Gtk2::Label(" Last fetch attempt :");
    $last_f_l->set_alignment(1.0, 0.0);
    $last_f_t = new Gtk2::Label();
    $last_f_t->set_alignment(0.0, 0.0);
    if ( $feed->last_fetched ) {
	$last_f_t->set_text(scalar(localtime $feed->last_fetched));
    } else {
	$last_f_t->set_text("No attempts yet");
    }

    #DESCRIPTION
    $desc_l = new Gtk2::Label(" Description :");
    $desc_l->set_alignment(1.0, 0.0);
    my $feed_desc = $feed->description || '< Available after first fetch >';
    $desc_t = new Gtk2::Label($feed_desc);
    $desc_t = Gtk2::TextView->new();
    $desc_t->set_wrap_mode('word');
    $desc_t->set_editable(0);
    my $buffer = $desc_t->get_buffer();
    $buffer->set_text($feed_desc );
    $desc_w = new Gtk2::ScrolledWindow(undef, undef);
    $desc_w->set_policy('automatic', 'automatic');
    $desc_w->add($desc_t);

    #SOURCE LINK
    $link_l = new Gtk2::Label(" Source link :");
    $link_l->set_alignment(1.0, 0.0);
    my $link_t;
    if ( $feed->source_link ) {
	$link_t = Gnome2::HRef->new($feed->source_link,$feed->source_link);
    } else {
	$link_t = new Gtk2::Label('< Available after first fetch >');
	$link_t->set_alignment(0.0, 0.0);
    }

    #RSS VERSION
    $version_l = new Gtk2::Label(" RSS Version :");
    $version_l->set_alignment(1.0, 0.0);
    $feed_rss_version = $feed->rss_version || '< Available after first fetch >';
    $version_e = new Gtk2::Label($feed_rss_version);
    $version_e->set_alignment(0.0, 0.0);


    
    $table_page2->attach( $status_l  ,0,1,0,1,['fill','shrink']         , [], 5,5);
    $table_page2->attach( $status_t  ,1,2,0,1,['fill','shrink','expand'], [], 5,5);
    $table_page2->attach( $last_f_l  ,0,1,1,2,['fill','shrink']         , [], 5,5);
    $table_page2->attach( $last_f_t  ,1,2,1,2,['fill','shrink','expand'], [], 5,5);
    $table_page2->attach( $desc_l    ,0,1,2,3,['fill','shrink']         , ['fill'], 5,5);
    $table_page2->attach( $desc_w    ,1,2,2,3,['fill','shrink','expand'], ['fill'], 5,5);
    $table_page2->attach( $link_l    ,0,1,3,4,['fill','shrink']         , [], 5,5);
    $table_page2->attach( $link_t    ,1,2,3,4,['fill','shrink','expand'], [], 5,5);
    $table_page2->attach( $version_l ,0,1,4,5,['fill','shrink']         , [], 5,5);
    $table_page2->attach( $version_e ,1,2,4,5,['fill','shrink','expand'], [], 5,5);


    
    $table_page2->show_all();
  $vbox_page2->pack_start($table_page2, 1,1,10);
 
  
  $s->{_button_box_page1} = new Gtk2::HButtonBox();
  $s->{_button_box_page1}->add( $s->{_apply_page1} );
  $s->{_button_box_page1}->add( $s->{_close_page1} );
  $s->{_button_box_page1}->set_layout_default('end');
  $vbox->pack_start($s->{_button_box_page1}, 0,0,0);
  $w->show_all();
}

sub _activate_apply {
  my $s = shift;
  $s->{_apply_page1}->set_sensitive(1);
  return 1;
}

sub _apply_changes {
  my $s = shift;

  if ($s->{_feed}->url() ne $s->{_url_e}->get_text ) { 
	  my $res = $s->{_feed}->url($s->{_url_e}->get_text);
	  unless ($res) {
		RSSReader::Gtk2UI::Dialog->run($@);
		return undef;
	  }
  }

  $s->{_feed}->label($s->{_name_e}->get_text);
  
  my $fetch_int = $s->{_feed}->fetch_interval();
  my $page_fetch_int = 0;

  if ( ! $s->{_fetch_int_d}->get_active ) {
	$page_fetch_int = $s->{_fetch_int_s}->get_value_as_int();
  }	

  $s->{_feed}->fetch_interval($page_fetch_int) if $fetch_int != $page_fetch_int;
  $s->{_feed}->notify_new_messages($s->{_notify_b}->get_active);
  $s->{_feed}->keep_for_n( ($s->{keep_for_x_s}->get_value_as_int()*86400) );
  
  $s->{_apply_page1}->set_sensitive(0);
  return 1;
}

1;
