package RSSReader::Gtk2UI::Fetcher;
use RSSReader;
use RSSReader::Gtk2UI;
use RSSReader::Gtk2UI::Preferences;
use base qw(RSSReader::Fetcher);

sub get_rss {
        my $c = shift;
	my $prefs = RSSReader::Gtk2UI::Preferences->new();
	if ( $prefs->option('http_proxy_enabled') ) {
		my $proxy = $prefs->option('http_proxy_host');
		my $port  = $prefs->option('http_proxy_port');
		my $proxy .= "\:$port" if defined($port);
		return $c->SUPER::get_rss(@_, http_proxy=>"$proxy",
				       callback=>sub {
						Gtk2->main_iteration 
						   while (Gtk2->events_pending);
						     },
		);
	} 
        else {
		return $c->SUPER::get_rss(@_, callback=>sub {
						Gtk2->main_iteration 
						   while (Gtk2->events_pending);
						     });
	}

}

sub add_msg_to_feed {
	my $c = shift;
	Gtk2->main_iteration while (Gtk2->events_pending);
	return $c->SUPER::add_msg_to_feed(@_);
}

1;
