package RSSReader::Gtk2UI::IconFactory;

my $IMAGE_DIR = '/usr/X11R6/share/gnome/pixmaps/syndigator/';

our @ICONS = (
	{ name 	   => 'notify',
	  filename => 'item-notify-gtk2.png',
	  label    => 'Marked for notifications',
	},
	{ name 	   => 'item',
	  filename => 'item-gtk2.png',
	  label    => 'item',
	},
	{ name 	   => 'tokeep',
	  filename => 'tokeep-gtk2.png',
	  label    => 'To Keep',
	},
	{ name 	   => 'post-comment',
	  filename => 'post-comment.png',
	  label    => 'Post a comment',
	},
	{ name     => 'logo-simple',
	  filename => 'logo-simple.gif',
	  label    => 'Syndigator',
	},
	{ name     => 'online',
	  filename => 'online.png',
	  label    => 'Work Online',
	},
	{ name     => 'offline',
	  filename => 'offline.png',
	  label    => 'Work Offline',
	},
	    );
	    
foreach my $i (@ICONS) {
	__PACKAGE__->generate_icon($i);
}

sub add_icon {
	my $c = shift;
	my %a = @_;
	my $icon = { name => $a{name},
		     filename => $a{file},
		     label => $a{label},
		   };
	$c->generate_icon($icon);
}

sub generate_icon {
	my $c = shift;
	my $i = shift;
	my $factory = Gtk2::IconFactory->new();
	$factory->add_default();
	my $pb = Gtk2::Gdk::Pixbuf->new_from_file( $IMAGE_DIR.$i->{filename} );
	$factory->add('syndigator-'.$i->{name}, Gtk2::IconSet->new_from_pixbuf($pb));
}

sub filename {
	my $c = shift;
	my $stock_id = shift;
	$stock_id =~ s/^syndigator-//;
	print STDERR "Looking for $stock_id\n";
	foreach my $s (@ICONS) {
		print STDERR "Found ".$s->{name}."\n" if $stock_id eq $s->{name};
		return $IMAGE_DIR.$s->{filename} if $stock_id eq $s->{name}; 
	}
	return undef;
}	

sub pixbuf {
	my $c = shift;
	my $stock_id = shift;
	my $file = $c->filename($stock_id);
	return unless $file;
	return Gtk2::Gdk::Pixbuf->new_from_file($file);
}

sub image {
	my $c = shift;
	my $stock_id = shift;
	my $file = $c->filename($stock_id);
	return unless $file;
	return Gtk2::Image->new_from_file($file);
}

1;
