package RSSReader::Gtk2UI::RenameCategoryWindow;
use strict;
use base qw( RSSReader::Logger );

sub run {
  my $c = shift;
  my %a = @_;
  return undef unless $a{category};

  my $s = bless {}, $c;

  my $window = new Gtk2::Window('toplevel');
  $window->set_title("Rename ".$a{category}->label());
  $window->set_modal(1);
  $window->set_transient_for( RSSReader::Gtk2UI::MainWindow->new()->widget );

  my $vbox = new Gtk2::VBox;

  my $text = "Rename category <b>".$a{category}->label."</b> to:";
  $text =~ s/&/&amp\;/g;
  my $label = new Gtk2::Label;
  $label->set_markup($text);
  $vbox->pack_start($label,1,1,1);

  my $name_e = new Gtk2::Entry(); 
  $vbox->pack_start($name_e,1,1,1);

  $vbox->pack_start(Gtk2::HSeparator->new,1,1,1);

  my $button_box = new Gtk2::HButtonBox();
  $button_box->set_layout_default('end');
  $button_box->set_spacing_default( 3);
  my $cancel_button = Gtk2::Button->new_from_stock('gtk-cancel');
  $cancel_button->signal_connect('clicked', sub { $s->{_widget}->destroy } );
  
  $button_box->add($cancel_button);
  my $ok_button = Gtk2::Button->new_from_stock('gtk-ok');
  $button_box->add($ok_button);

  $vbox->pack_start($button_box,1,1,1);
  
  $vbox->set_border_width(5);
  $vbox->show_all;
  $window->add($vbox); 

  $window->show_all();

  $s = bless { _widget => $window, _entry => $name_e, _cat=> $a{category} }, $c;
  $ok_button->signal_connect('clicked', sub { $s->rename_it() });
}

sub rename_it {
  my $s = shift;
  $s->log_debug("Rename ".$s->{_cat}->label()." to ".$s->{_entry}->get_text());
  $s->{_cat}->set_label(new_label=>$s->{_entry}->get_text());
  $s->{_widget}->destroy;

  return;
}
1;
